#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

struct Globals
{
    float4x4 uVP;
    packed_float3 uOffset;
    float uLayer;
    float uAlpha;
};

struct main0_out
{
    float2 vUV [[user(locn0)]];
    float4 gl_Position [[position]];
};

struct main0_in
{
    float3 aPos [[attribute(0)]];
    float2 aUV [[attribute(1)]];
};

vertex main0_out main0(main0_in in [[stage_in]], constant Globals& _26 [[buffer(0)]])
{
    main0_out out = {};
    out.vUV = in.aUV;
    out.gl_Position = _26.uVP * float4(in.aPos + float3(_26.uOffset), 1.0);
    out.gl_Position.z = (out.gl_Position.z + out.gl_Position.w) * 0.5;
    return out;
}

